package com.example.quizapp2;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.CollectionReference;
import com.google.firebase.firestore.EventListener;
import com.google.firebase.firestore.FirebaseFirestore;
import com.google.firebase.firestore.FirebaseFirestoreException;
import com.google.firebase.firestore.QueryDocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;

import java.util.ArrayList;


public class MainActivity extends AppCompatActivity implements AdapterView.OnItemSelectedListener{

    private static final int REQUEST_CODE_QUIZ = 1;
    public static  String EXTRA_CATEGORY = "extraCategory";


    public static final String SHARED_PREFS="sharedPrefs";
    public static final String KEY_HIGHSCORE="keyHigscore";

    private TextView textViewHighscore;
    public Spinner spinnerCategory;

    private int highscore;
    public static  ArrayList<String> categoryList= new ArrayList<String>();



    private FirebaseFirestore db = FirebaseFirestore.getInstance();
    private CollectionReference questionsRef = db.collection("Questions");




    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        textViewHighscore=findViewById(R.id.text_view_highscore);
        spinnerCategory=(Spinner)findViewById(R.id.spinner_category);

        loadCategories();

        loadHighstore();

        Button buttonStartQuiz=findViewById(R.id.button_start_quiz) ;
        buttonStartQuiz.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                startQuiz();
            }
        });
    }


    public void startQuiz(){

       // Question selectedCategory = (Question)spinnerCategory.getSelectedItem();
        // String categoryName=selectedCategory.getCategory();
        String category = spinnerCategory.getSelectedItem().toString();

        // Toast.makeText(MainActivity.this,category,Toast.LENGTH_SHORT).show();

        Intent intent = new Intent(MainActivity.this,QuizActivity.class);

        intent.putExtra(EXTRA_CATEGORY, category);
        //Toast.makeText(MainActivity.this, "to jest metoda klasa Toast "+category, Toast.LENGTH_SHORT).show();
       startActivityForResult(intent,REQUEST_CODE_QUIZ);
      // startActivity(intent);

    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if(requestCode==REQUEST_CODE_QUIZ){
            if(resultCode==RESULT_OK){
                int score=data.getIntExtra(QuizActivity.EXTRA_SCORE,0);
                if(score>highscore){
                    updateHighscore(score);
                }
            }

        }
    }



    private void loadHighstore(){
        SharedPreferences prefs=getSharedPreferences(SHARED_PREFS,MODE_PRIVATE);
        highscore=prefs.getInt(KEY_HIGHSCORE,0);
        textViewHighscore.setText("Highscore 123:  "+highscore);
    }


    private void updateHighscore(int highscoreNew){
        highscore=highscoreNew;
        textViewHighscore.setText("Highscore :  "+highscore);
        SharedPreferences prefs=getSharedPreferences(SHARED_PREFS,MODE_PRIVATE);
        SharedPreferences.Editor editor =prefs.edit();
        editor.putInt(KEY_HIGHSCORE, highscore);
        editor.apply();
    }


    private void loadCategories(){

        // final  ArrayList<String> categoryFromDb =new ArrayList<>();
        //
        //categoryList.
        //categoryList.add("HTML");
        if(categoryList.size()==0) {
            categoryList.add(0,(String)"HTML");

            db.collection("Questions")
                    .get()
                    .addOnCompleteListener(new OnCompleteListener<QuerySnapshot>() {
                        @Override
                        public void onComplete(@NonNull Task<QuerySnapshot> task) {
                            if (task.isSuccessful()) {
                                String test="";
                                for (QueryDocumentSnapshot document : task.getResult()) {
                                    //Log.d("zzz", document.getId() + " => " + document.getData());
                                    //   Toast.makeText(MainActivity.this, "JEST OK"+document.get("category"), Toast.LENGTH_SHORT).show();
                                    if (!categoryList.contains((String) document.get("category")))
                                        categoryList.add((String) document.get("category"));

                                }
     /*
                         for(int i=0; i<categoryList.size(); i++)
                             Toast.makeText(MainActivity.this, categoryList.get(i), Toast.LENGTH_SHORT).show();
                               Toast.makeText(MainActivity.this,String.valueOf(categoryList.size()) , Toast.LENGTH_SHORT).show();
  */
                            }

                        }
                    });

        }

        ArrayAdapter<String> adapterCategories= new ArrayAdapter<String>(MainActivity.this, android.R.layout.simple_spinner_item, categoryList);
        adapterCategories.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinnerCategory.setAdapter(adapterCategories);
        spinnerCategory.setOnItemSelectedListener(this);


    }


    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int i, long l) {
        EXTRA_CATEGORY=parent.getItemAtPosition(i).toString();
        Toast.makeText(MainActivity.this, "to aaa jest "+ EXTRA_CATEGORY, Toast.LENGTH_SHORT).show();
    }



    @Override
    public void onNothingSelected(AdapterView<?> adapterView) {

    }

}
