package com.example.quizapp2;

import android.content.Intent;
import android.graphics.Color;
import android.content.res.ColorStateList;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.firestore.CollectionReference;
import com.google.firebase.firestore.FirebaseFirestore;
import com.google.firebase.firestore.QuerySnapshot;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import static java.util.Collections.shuffle;


public class QuizActivity extends AppCompatActivity {
    public static final String EXTRA_SCORE = "extraScore";

    private static final String KEY_SCORE = "keyScore";
    private static final String KEY_QUESTION_COUNT = "keyQuestionCount";
    private static final String KEY_ANSWERED = "keyAnswered";
    private static final String KEY_QUESTION_LIST = "keyQuestionList";


    private TextView textViewQuestion;
    private TextView textViewScore;
    private TextView textViewQuestionCount;
    private TextView textViewCategory;
    private RadioGroup rbGroup;
    private RadioButton rb1;
    private RadioButton rb2;
    private RadioButton rb3;
    private RadioButton rb4;
    private Button buttonConfirmNext;

    private ColorStateList textColorDefaultRb;
    private ColorStateList textColorDefaultCd;

    //private ArrayList<Question> questionList;
    private int questionCounter;
    private int questionCountTotal;
    private Question currentQuestion;




    public static ArrayList<Question> questionList = new ArrayList<Question>();

    // public ArrayList<Question> questionList; -generuje błąd, bo bez konstruktora
    public FirebaseFirestore db = FirebaseFirestore.getInstance();
    public CollectionReference questionsRef = db.collection("Questions");


    private int score;
    private boolean answered;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_quiz);

         textViewQuestion = (TextView)findViewById(R.id.text_view_question);
         textViewScore = (TextView)findViewById(R.id.text_view_score);
         textViewQuestionCount =(TextView)findViewById(R.id.text_view_question_count);
        TextView textViewCategory = (TextView)findViewById(R.id.text_view_category);


         rbGroup = findViewById(R.id.radio_group);
         rb1 = findViewById(R.id.radio_button1);
         rb2 = findViewById(R.id.radio_button2);
         rb3 = findViewById(R.id.radio_button3);
         rb4 = findViewById(R.id.radio_button4);
        buttonConfirmNext = findViewById(R.id.button_confirm_next);



        textColorDefaultRb = rb1.getTextColors();
        //  ColorStateList textColorDefaultCd = textViewCountDown.getTextColors();
        Intent intent = getIntent();
        String category = intent.getStringExtra(MainActivity.EXTRA_CATEGORY);
        Toast.makeText(QuizActivity.this,"kategoria quiz activity"+ category, Toast.LENGTH_LONG).show();


        if (savedInstanceState == null) {
             QuizDbHelper dbHelper = new QuizDbHelper(this);
            // QuizDbHelper dbHelper = QuizDbHelper.getInstance(this);

            textViewCategory.setText("quizActivity: " + category);
            questionList = dbHelper.getQuestions(category);
                    //   questionsArrayList(category);
            questionCountTotal = questionList.size();
            Collections.shuffle(questionList);
            Toast.makeText(QuizActivity.this,"quizActivity: ilosc-quest total-----: "+ String.valueOf(questionCountTotal), Toast.LENGTH_LONG).show();

            //  questionCountTotal = questionList.size();
            //textViewQuestionCount.setText("ilość: " + String.valueOf(questionCountTotal));


            // questionList = getAllQuestions(category);

           // shuffle(questionList);
             showNextQuestion();
        } else {
            // questionList = savedInstanceState.getParcelableArrayList(KEY_QUESTION_LIST);
            questionCountTotal = questionList.size();
            textViewQuestionCount.setText("quizActivity:  " + String.valueOf(questionCountTotal));
            questionCounter = savedInstanceState.getInt(KEY_QUESTION_COUNT);
            currentQuestion = questionList.get(questionCounter - 1);
            score = savedInstanceState.getInt(KEY_SCORE);
            answered = savedInstanceState.getBoolean(KEY_ANSWERED);
            if (!answered) {
               // startCountDown();
            } else {

                showSolution();
            }

        }

        buttonConfirmNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!answered) {
                    if (rb1.isChecked() || rb2.isChecked() || rb3.isChecked() ||  rb4.isChecked()) {
                        checkAnswer();
                    } else {
                        Toast.makeText(QuizActivity.this, "Please select an answer", Toast.LENGTH_SHORT).show();
                    }
                } else {
                    showNextQuestion();
                }
            }
        });
    }



/*
    public void  questionsArrayList(String category) {

    }



    private void showSolution() {
        rb1.setTextColor(Color.RED);
        rb2.setTextColor(Color.RED);
        rb3.setTextColor(Color.RED);

        switch (currentQuestion.getAnswerNr()) {
            case 1:
                rb1.setTextColor(Color.GREEN);
                textViewQuestion.setText("Answer 1 is correct");
                break;
            case 2:
                rb2.setTextColor(Color.GREEN);
                textViewQuestion.setText("Answer 2 is correct");
                break;
            case 3:
                rb3.setTextColor(Color.GREEN);
                textViewQuestion.setText("Answer 3 is correct");
                break;
        }

        if (questionCounter < questionCountTotal) {
            buttonConfirmNext.setText("Next");
        } else {
            buttonConfirmNext.setText("Finish");
        }
    }

    */





    private void finishQuiz() {
        Intent resultIntent = new Intent();
        resultIntent.putExtra(EXTRA_SCORE, score);
        setResult(RESULT_OK, resultIntent);
        finish();
    }





    @Override
    public void onBackPressed() {

          //  finishQuiz();

            Toast.makeText(this, "Press back again to finish", Toast.LENGTH_SHORT).show();

    }




    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putInt(KEY_SCORE, score);
        outState.putInt(KEY_QUESTION_COUNT, questionCounter);

        outState.putBoolean(KEY_ANSWERED, answered);
        outState.putParcelableArrayList(KEY_QUESTION_LIST, questionList);
    }


    private void showNextQuestion() {
        rb1.setTextColor(textColorDefaultRb);
        rb2.setTextColor(textColorDefaultRb);
        rb3.setTextColor(textColorDefaultRb);
        rbGroup.clearCheck();

        if (questionCounter < questionCountTotal) {
            currentQuestion = questionList.get(questionCounter);

            textViewQuestion.setText(currentQuestion.getQuestion());
            rb1.setText(currentQuestion.getOption1());
            rb2.setText(currentQuestion.getOption2());
            rb3.setText(currentQuestion.getOption3());
            rb4.setText(currentQuestion.getOption4());
            questionCounter++;
            textViewQuestionCount.setText("Question: " + questionCounter + "/" + questionCountTotal);
            answered = false;
            buttonConfirmNext.setText("Confirm");

            //timeLeftInMillis = COUNTDOWN_IN_MILLIS;
          //  startCountDown();
        } else {
            finishQuiz();
        }
    }





    private void checkAnswer() {
        answered = true;

        RadioButton rbSelected = findViewById(rbGroup.getCheckedRadioButtonId());
        //int answerNr = rbGroup.indexOfChild(rbSelected) ;

        if (currentQuestion.getAnswerRight().equals(rbSelected.getText())) {
            score++;
            textViewScore.setText("Score: " + score);
        }

        showSolution();
    }







    private void showSolution() {
        rb1.setTextColor(Color.RED);
        rb2.setTextColor(Color.RED);
        rb3.setTextColor(Color.RED);
        rb4.setTextColor(Color.RED);
        if(currentQuestion.getAnswerRight().equals(rb1.getText())){
            rb1.setTextColor(Color.GREEN);
            textViewQuestion.setText("Answer 1 is correct");
        }
        else if(currentQuestion.getAnswerRight().equals(rb2.getText())){
            rb2.setTextColor(Color.GREEN);
            textViewQuestion.setText("Answer 2 is correct");
        }
        else if(currentQuestion.getAnswerRight().equals(rb3.getText())){
            rb3.setTextColor(Color.GREEN);
            textViewQuestion.setText("Answer 3 is correct");
        }
        else if(currentQuestion.getAnswerRight().equals(rb4.getText())){
            rb4.setTextColor(Color.GREEN);
            textViewQuestion.setText("Answer 4 is correct");
        }

/*
        switch (currentQuestion.getAnswerRight()) {
            case 1:
                rb1.setTextColor(Color.GREEN);
                textViewQuestion.setText("Answer 1 is correct");
                break;
            case 2:
                rb2.setTextColor(Color.GREEN);
                textViewQuestion.setText("Answer 2 is correct");
                break;
            case 3:
                rb3.setTextColor(Color.GREEN);
                textViewQuestion.setText("Answer 3 is correct");
                break;
        }
        */

        if (questionCounter < questionCountTotal) {
            buttonConfirmNext.setText("Next");
        } else {
            buttonConfirmNext.setText("Finish");
        }
    }








}